package pigbarf;

import java.io.*;
import javax.xml.parsers.ParserConfigurationException;

public class Main {
   public static void main(String args[]) {
      if (args.length < 1) {
         System.err.println("USAGE: Main <spec.xml> <class name>");
         System.exit(1);
      }

      try {
         MetaParser parser = new MetaParser();
         Specification spec = parser.process(new FileInputStream(args[0]));
         Generator generator = new Generator(spec, args[1]);
         generator.generateParser(System.out);
      } catch (ParserConfigurationException pce) {
         System.err.println("Error: Cannot build XML parser: " + pce.getMessage());
         System.exit(1);
      } catch (IOException ioe) {
         System.err.println("Error: Cannot read from stream: " + ioe.getMessage());
         System.exit(1);
      } catch (MetaParsingException mpe) {
         System.err.println("Error: Cannot parse specification: " + mpe.getMessage());
         System.exit(1);
      }
   }
}
