package pigbarf;

public enum Primitive {
	BIT("boolean"),
	BITS("java.util.BitSet"),
	BYTE("byte"),
	BYTES("byte[]"),
	INT("int"),
	LONG("long"),
	SHORT("short"),
	CHAR("char"),
	CHARS("char[]"),
	FLOAT("float"),
	DOUBLE("double");
	
	private final SimpleType defaultType;
	private Primitive(String _type) {this.defaultType = new SimpleType(_type);}
	public SimpleType getDefaultType() {return this.defaultType;}
	
	public static Primitive getByName(String name) {
		for (Primitive p : values()) {
			if (p.name().toLowerCase().equals(name))
				return p;
		}
		return null;
	}
}
