package pigbarf;

import java.util.ArrayList;
import java.util.List;

public class Rule {
	private Type type;
	private List<String> formals = new ArrayList<String>();
	private final String name;
	private final List<RHS> options = new ArrayList<RHS>();
	
	public Rule(String _name, List<String> _formals) {
		this.name = _name;
		this.formals.addAll(_formals);
	}
	
	public Type getType() {return this.type;}
	public void setType(Type t) {this.type = t;}
	
	public String getName() {return this.name;}
	
	public int getNumParameters() {return this.formals.size();}
	public String getFormalName(int i) {return this.formals.get(i);}

   public void addOption(RHS rhs) {this.options.add(rhs);}
   public int getNumOptions() {return this.options.size();}
   public RHS getOption(int i) {return this.options.get(i);}
	
   public String toString() {
      StringBuilder builder = new StringBuilder();
      builder.append(this.type).append(" : ").append(this.name);
      if (this.formals.size() > 0) {
         builder.append('(');
         for (int i = 0; i < this.formals.size(); i++) {
            if (i>0) builder.append(", ");
            builder.append(this.formals.get(i));
         }
         builder.append(')');
      }
      builder.append(" ::=");
      for (int i = 0; i < this.options.size(); i++) {
         if (i>0) builder.append(" |");
         builder.append(this.options.get(i));
      }
      return builder.append(" ;;").toString();
   }
}
