package pigbarf;

import java.util.ArrayList;
import java.util.List;

public class Specification {
	private final List<Rule> rules = new ArrayList<Rule>();
	private String headers;
	private boolean byteOrderBE = true;
	private boolean bitOrderBE = true;
	private Rule startRule;
	
	public Specification() {}
	
	public void setByteOrder(boolean isBE) {this.byteOrderBE = isBE;}
	public boolean isByteOrderBE() {return this.byteOrderBE;}
	
	public void setBitOrder(boolean isBE) {this.bitOrderBE = isBE;}
	public boolean isBitOrderBE() {return this.bitOrderBE;}
	
	public String getHeaders() {return this.headers;}
	public void setHeaders(String _headers) {this.headers = _headers;}

	public void setStartRule(Rule s) {this.startRule = s;}
	public Rule getStartRule() {return this.startRule;}
	
	public void addRule(Rule rule) {this.rules.add(rule);}
	public int getNumRules() {return this.rules.size();}
	public Rule getRule(int i) {return this.rules.get(i);}
	public Rule getRuleByName(String name) {
		for (Rule r : this.rules) {
			if (r.getName().equals(name))
				return r;
		}
		return null;
	}
}
